       IDENTIFICATION DIVISION.
       PROGRAM-ID. A1.
      *
      ****************************************************************
      * EINGABEDATEN: SCHLERDATEI
      *      AUFBAU:
      *         1 - 80 ... SCHLERDATEN
      *                    (WIE NAME, GEBURTSDATUM, ADRESSE USW.)
      *---------------------------------------------------------------
      * AUSGABEDATEN: SCHLERLISTE
      *      AUFBAU:   1 ZEILE PRO SCHLER MIT ALLEN SCHLERDATEN
      *                              (D.H. MIT DEM DATENSATZINHALT)
      ****************************************************************
       ENVIRONMENT DIVISION.
      *
      * --- Datei-Definitionen ------------------
      *
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT VORMERK ASSIGN TO VORMERK.
           SELECT LISTE   ASSIGN TO LISTE.
      * -----------------------------------------
       DATA DIVISION.
       FILE SECTION.
      *
      * --- DATENFELD-DEFINITIONEN --------------
      *
       FD  VORMERK.
       01  EB       PIC X(80).
       FD  LISTE.
       01  AB       PIC X(80).
      *
       WORKING-STORAGE SECTION.
       77  EOF      PIC 9 VALUE 0.
      * -----------------------------------------
       PROCEDURE DIVISION.
       ANFANG.
           OPEN INPUT VORMERK OUTPUT LISTE.
      *
      * --- Struktogramm ------------------------
      *
           READ VORMERK AT END MOVE 1 TO EOF.
           PERFORM WITH TEST BEFORE UNTIL EOF = 1
               MOVE EB TO AB
               WRITE AB
               READ VORMERK AT END MOVE 1 TO EOF
               END-READ
           END-PERFORM.
      * -----------------------------------------
           CLOSE VORMERK LISTE.
           STOP RUN.
