// Autor: Mag. Johann Preissl
//
#include <windows.h>
#include <time.h>
#include <stdlib.h>

HANDLE holeoutput()    // Hilfsfunktion fr die Ausgabe
{
    // Variante 1, nehme den stdout

	return GetStdHandle(STD_OUTPUT_HANDLE);

    // Variante 2 - nehme immer die Console

//	return CreateFile( "CONOUT$", GENERIC_WRITE | GENERIC_READ,
//                     FILE_SHARE_READ | FILE_SHARE_WRITE,
//                     0L, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0L);
}

void clrscr( ) 
{
   COORD    coordScreen = { 0, 0 };        /* Struktur fr Position am Schirm */
   HANDLE   hConsole;                      /* Win32 Fenster Zugriffshandle */
   BOOL     bSuccess;
   DWORD    cCharsWritten;
   CONSOLE_SCREEN_BUFFER_INFO csbi;        /*  buffer info Struktur */
   DWORD    dwConSize;                     /* Zeichenzahl am Schirm */
 
   hConsole = holeoutput();
 
   bSuccess = GetConsoleScreenBufferInfo(hConsole, &csbi);

   dwConSize = csbi.dwSize.X * csbi.dwSize.Y;        // anz-spalten * anz-zeilen
 
   /* alles blanks */
   bSuccess = FillConsoleOutputCharacter(hConsole, (TCHAR) ' ',
                                         dwConSize, coordScreen, &cCharsWritten);
 
   bSuccess = GetConsoleScreenBufferInfo(hConsole, &csbi);
 
   /* now set the buffer's attributes accordingly   ?? wozu wohl  */
   bSuccess = FillConsoleOutputAttribute(hConsole, csbi.wAttributes,
                                         dwConSize, coordScreen, &cCharsWritten);
 
   /* positioniere cursor auf (0, 0) */
   bSuccess = SetConsoleCursorPosition(hConsole, coordScreen);

   return;
}
