/* bung A17 (Version 1)
   Autor: Beringer Alfred
   Sortieren von Zahlenfolgen (einfacher Bubble-Sort).
 ---------------------------------------------------------------
  EINGABEDATEN: ZAHLENDATEI
       AUFBAU:
         1 - 10 (10) ... ZAHL X
        11 - 20 (10) ... ZAHL Y
        21 - 30 (10) ... ZAHL Z
 ---------------------------------------------------------------
  AUSGABEDATEN: BLOCKLISTE
       AUFBAU:
         3 ZEILEN FR JEDEN DATENSATZ:
             1. ZEILE MIT
                 X, Y, Z IN EINGABEREIHENFOLGE
                            SOWIE TEXT 'UNSORTIERT'
             2. ZEILE MIT
                 X, Y, Z IN SORTIERTER REIHENFOLGE
                            SOWIE TEXT 'SORTIERT'
             1 LEERZEILE
 
  PRO SEITE MAXIMAL 20 ZEILEN.
 ---------------------------------------------------------------
*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include "..\\Headerdateien\\clrscr.h"
#include "..\\Headerdateien\\makros.h"

#include "..\\Headerdateien\\zahlen-EBER.h"

#define EINGABEDATEI  "..\\Dateien\\zahlen.datC"

#define LIM     7

#define F_ABER  "%10ld    %10ld    %10ld    %s\n"

struct ABER
{
  long int ax,
           ay,
           az;
  char     atext[10+1];
};

void upsort(EBER &eber);
void uptauschxy(EBER &eber);
void uptauschyz(EBER &eber);

void main()
{
  FILE *ZAHLEN;
  //    BLOCK = Standardausgabe stdout

  EBER eber;
  ABER aber;
  char text1[] = "UNSORTIERT";
  char text2[] = "SORTIERT  ";
  short int bz = 99;

  ZAHLEN = fopen(EINGABEDATEI,"rb");

  fread(&eber,sizeof(eber),1,ZAHLEN);
  while (!feof(ZAHLEN))
  {
    aber.ax = eber.ex;
    aber.ay = eber.ey;
    aber.az = eber.ez;
    strcpy(aber.atext,text1);
    if (bz >= LIM)
    {
      NEUESEITE;
      bz = 0;
    }
    printf(F_ABER,aber.ax,aber.ay,aber.az,aber.atext);
    upsort(eber);
    aber.ax = eber.ex;
    aber.ay = eber.ey;
    aber.az = eber.ez;
    strcpy(aber.atext,text2);
    printf(F_ABER,aber.ax,aber.ay,aber.az,aber.atext);
    LEERZEILE;
    bz++;
    fread(&eber,sizeof(eber),1,ZAHLEN);
  }

  fclose(ZAHLEN);

  _getch();
} /* ----- Ende main */

void upsort(EBER &eber)
{
  char schtausch;
  const char ja   = 'J',
             nein = 'N';

  schtausch = ja;
  while (schtausch == ja)
  {
    schtausch = nein;
    if (eber.ex > eber.ey)
    {
      uptauschxy(eber);
      schtausch = ja;
    }
    if (eber.ey > eber.ez)
    {
      uptauschyz(eber);
      schtausch = ja;
    }
  }
} /* ----- Ende upsort */

void uptauschxy(EBER &eber)
{
  long int hilf;

  hilf = eber.ex;
  eber.ex = eber.ey;
  eber.ey = hilf;
} /* ----- Ende uptauschxy */

void uptauschyz(EBER &eber)
{
  long int hilf;

  hilf = eber.ey;
  eber.ey = eber.ez;
  eber.ez = hilf;
} /* ----- Ende uptauschyz */
