/* bung A25
   Autor: Beringer Alfred
   Schlerzahlen - einfacher Gruppenwechsel.
 ---------------------------------------------------------------
  EINGABEDATEN: SCHLERDATEI
       AUFBAU:
         1 - 20 (20) ... FAMILIENNAME
        21 - 30 (10) ... VORNAME
           31   ( 1) ... GESCHLECHT
        32 - 39 ( 8) ... GEBURTSDATUM (IN DER FORM JJJJMMTT)
        40 - 41 ( 2) ... RELIGION (VERSCHLSSELT)
        42 - 44 ( 3) ... STAATSBRGERSCHAFT
        45 - 49 ( 5) ... KLASSE
        50 - 53 ( 4) ... POSTLEITZAHL
        54 - 65 (12) ... ORT
        66 - 80 (15) ... STRASSE
 
  DIE DATENSTZE SIND AUFSTEIGEND SORTIERT NACH DER KLASSE.
 ---------------------------------------------------------------
  AUSGABEDATEN: KLASSEZAHLEN
       AUFBAU:
         1 SPALTENBERSCHRIFT UND
         1 LEERZEILE
 
         1 ZEILE FR JEDE KLASSE MIT
             KLASSE
             ANZAHL SCHLER DER KLASSE
 
         1 LEERZEILE UND
         1 GESAMTSUMMENZEILE MIT
             GESAMTANZAHL ALLER SCHLER
 
  PRO SEITE MAXIMAL 20 ZEILEN
      (EINSCHL. BERSCHRIFT + LEERZEILE),
      AUSGENOMMEN DIE LETZTE SEITE.
  DIE SUMMENZEILE SOLL NICHT UNMITTELBAR AUF DIE
  BERSCHRIFT FOLGEN.
 ---------------------------------------------------------------
*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include "..\\Headerdateien\\clrscr.h"
#include "..\\Headerdateien\\makros.h"

#include "..\\Headerdateien\\schueler-EB.h"

//#define EINGABEDATEI  "..\\Dateien\\vormerk.datC"
#define EINGABEDATEI  "..\\Dateien\\schueler.datC"

#define ZMAX   20
#define HIGH   "\xff\xff\xff\xff\xff"

#define ABUE   "                            KLASSE          SCHUELERZAHL\n"
#define F_AB   "                             %s               %2hd \n"
#define F_ABS  "                 GESAMTANZAHL ALLER SCHUELER:  %4hd \n"
#define F_ABF  "SORTIERFOLGEFEHLER BEI %s \n"

struct AB
{
  char      akl[5+1];
  short int asum;
};

struct ABS
{
  short int agsum;
};

struct ABF
{
  char afkl[5+1];
};

static FILE *SCHULE;
//           KLIST = Standardausgabe stdout

void uprogvor (short int &gsum,
               short int &zz);
void uplesen  (EB &eb);
void upgrvor  (EB eb,
               AB &ab,
               char vkl[],
               short int &sum);
void upeinzel (short int &sum);
void upgrnach (AB ab,
               short int sum,
               short int &gsum,
               short int &zz);
void upsort   (EB eb,
               char vkl[],
               short int &zz);
void uprognach(short int gsum);
void upueb    (short int &zz);

void main()
{
  EB   eb;
  AB   ab;
  char vkl [5+1];
  short int sum,
            gsum;
  short int zz;

  SCHULE = fopen(EINGABEDATEI,"rb");

  uprogvor(gsum,zz);
  uplesen(eb);
  while (strcmp(eb.ekl,HIGH) != 0)
  {
    upgrvor(eb,ab,vkl,sum);
    while (strcmp(eb.ekl,vkl) == 0)
    {
      upeinzel(sum);
      uplesen(eb);
    }
    upgrnach(ab,sum,gsum,zz);
    upsort(eb,vkl,zz);
  }
  uprognach(gsum);

  fclose(SCHULE);

  _getch();
} /* ----- Ende main */

void uplesen(EB &eb)
{
  fread(&eb,sizeof(eb),1,SCHULE);
  if (feof(SCHULE))
    strcpy(eb.ekl,HIGH);
} /* ----- Ende uplesen */

void uprogvor(short int &gsum,
              short int &zz)
{
  zz = ZMAX;
  gsum = 0;
} /* ----- Ende uprogvor */

void upgrvor(EB eb,
             AB &ab,
             char vkl[],
             short int &sum)
{
  sum = 0;
  strcpy(ab.akl,eb.ekl);
  strcpy(vkl,eb.ekl);
} /* ----- Ende upgrvor */

void upeinzel(short int &sum)
{
  sum++;
} /* ----- Ende upeinzel */

void upgrnach(AB ab,
              short int sum,
              short int &gsum,
              short int &zz)
{
  ab.asum = sum;
  upueb(zz);
  printf(F_AB,ab.akl,ab.asum);
  zz++;
  gsum = gsum + sum;
} /* ----- Ende upgrnach */

void upsort(EB eb,
            char vkl[],
            short int &zz)
{
  ABF abf;

  if (strcmp(eb.ekl,vkl) < 0)
  {
    strcpy(abf.afkl,eb.ekl);
    upueb(zz);
    printf(F_ABF,abf.afkl);
    zz++;
  }
} /* ----- Ende upsort */

void uprognach(short int gsum)
{
  ABS abs;
  
  LEERZEILE;
  abs.agsum = gsum;
  printf(F_ABS,abs.agsum);
} /* ----- Ende uprognach */

void upueb(short int &zz)
{
  if (zz >= ZMAX)
  {
    NEUESEITE;
    printf(ABUE);
    LEERZEILE;
    zz = 2;
  }
} /* ----- Ende upueb */
