       IDENTIFICATION DIVISION.
       PROGRAM-ID. A3.
      *
      ****************************************************************
      * EINGABEDATEN: SCHLERDATEI
      *      AUFBAU:
      *        1 - 20 (20) ... FAMILIENNAME
      *       21 - 30 (10) ... VORNAME
      *          31   ( 1) ... GESCHLECHT
      *       32 - 39 ( 8) ... GEBURTSDATUM (IN DER FORM JJJJMMTT)
      *       40 - 41 ( 2) ... RELIGION (VERSCHLSSELT)
      *       42 - 44 ( 3) ... STAATSBRGERSCHAFT
      *       45 - 49 ( 5) ... KLASSE
      *       50 - 53 ( 4) ... POSTLEITZAHL
      *       54 - 65 (12) ... ORT
      *       66 - 80 (15) ... STRASSE
      *---------------------------------------------------------------
      * AUSGABEDATEN: SCHLERLISTE
      *      AUFBAU:
      *        1 ZEILE PRO SCHLER MIT
      *            FAMILIENNAME
      *            VORNAME
      *            GEBURTSDATUM
      *
      * PRO SEITE MAXIMAL 60 ZEILEN
      ****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT VORMERK ASSIGN TO VORMERK.
           SELECT LISTE   ASSIGN TO LISTE.
      *
       DATA DIVISION.
       FILE SECTION.
       FD  VORMERK.
      *
       01  EB.
           02 EFN    PIC X(20).
           02 EVN    PIC X(10).
           02 FILLER PIC X(1).
           02 EGD    PIC X(8).
           02 FILLER PIC X(41).
      *
       FD  LISTE.
       01  DBER      PIC X(76).
      *
       WORKING-STORAGE SECTION.
       01  AB.
           02 CC     PIC X      VALUE SPACE.
           02 FILLER PIC X(25)  VALUE SPACE.
           02 AFN    PIC X(20).
           02 FILLER PIC X(5)   VALUE SPACE.
           02 AVN    PIC X(10).
           02 FILLER PIC X(7)   VALUE SPACE.
           02 AGD    PIC X(8).
      *
       77  ZZG       PIC 99     VALUE 60  COMP-3.
       77  ZZ        PIC 99               COMP-3.
      *
       77  K0        PIC 9      VALUE 0   COMP-3.
       77  K1        PIC 9      VALUE 1   COMP-3.
      *
       77  EOF       PIC 9      VALUE 0.
      *
       PROCEDURE DIVISION.
       ANFANG.
           OPEN INPUT VORMERK OUTPUT LISTE.
      *
           MOVE K0 TO ZZ.
           READ VORMERK AT END MOVE 1 TO EOF.
           PERFORM WITH TEST BEFORE UNTIL EOF = 1
               MOVE EFN TO AFN
               MOVE EVN TO AVN
               MOVE EGD TO AGD
               IF ZZ NOT LESS ZZG THEN
                   MOVE SPACE TO DBER
                   WRITE DBER AFTER PAGE
                   MOVE K0 TO ZZ
               END-IF
               WRITE DBER FROM AB AFTER 1
               ADD K1 TO ZZ
               READ VORMERK AT END MOVE 1 TO EOF
               END-READ
           END-PERFORM.
      *
           CLOSE VORMERK LISTE.
           STOP RUN.
