/* bung A05
   Autor: Beringer Alfred
   Vertreterliste - Auswahl von Datenstzen,
                    Verwendung von Unterprogrammen bzw. Funktionen.
 ---------------------------------------------------------------
  EINGABEDATEN: VERTRETERUMSATZDATEI
       AUFBAU:
         1 -  6 ( 6) ... VERTRETERNUMMER
         7 - 35 (29) ... VERTRETERNAME
        36 - 46 (11) ... VERTRETERUMSATZ (2 NACHKOMMASTELLEN)
 ---------------------------------------------------------------
  AUSGABEDATEN: VERTRETERUMSATZLISTE
       AUFBAU:
         1 SPALTENBERSCHRIFT UND
         1 LEERZEILE
 
         1 ZEILE FR JENE VERTRETER, DEREN UMSATZ GRSSER
            ALS 300.000,-- EURO IST.
            JEDE ZEILE MIT
               VERTRETERNAME
               VERTRETERUMSATZ
 
  PRO SEITE MAXIMAL 20 ZEILEN.
  DIE BERSCHRIFT SOLL NUR AM VERARBEITUNGSBEGINN GESCHRIEBEN
  WERDEN.
 ---------------------------------------------------------------
*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include "..\\Headerdateien\\clrscr.h"
#include "..\\Headerdateien\\makros.h"

#include "..\\Headerdateien\\vertret-EIN.h"

#define EINGABEDATEI  "..\\Dateien\\vertreter.datC"

#define ZZG      20
#define VGL      300000.0f

#define OUTKOPF  "VERTRETER MIT UMSAETZEN UEBER EUR 300.000,-- \n"
#define F_OUT    "%s % 13.2f\n"

// OUT ist ein ungltiger Strukturdeklarationsname
struct OUTT
{
  char  anam[29+1];
  float aums;
};

void ueber(short int &zz);
void ausgabe(EIN ein, OUTT &out, short int &zz);

void main()
{
  FILE *VERTRET;
  //    UMSATZ = Standardausgabe stdout

  EIN  ein;
  OUTT out;
  short int zz;

  VERTRET = fopen(EINGABEDATEI,"rb");

  ueber(zz);
  fread(&ein,sizeof(ein),1,VERTRET);
  while (!feof(VERTRET))
  {
    if (ein.eums >= VGL)
      ausgabe(ein,out,zz);
    fread(&ein,sizeof(ein),1,VERTRET);
  }

  fclose(VERTRET);

  _getch();
} /* ----- Ende main */

void ueber(short int &zz)
{
  const short int K2 = 2;

  NEUESEITE;
  printf(OUTKOPF);
  LEERZEILE;
  zz = K2;
} /* ----- Ende ueber */

void ausgabe(EIN ein, OUTT &out, short int &zz)
{
  const short int K0 = 0,
                  K1 = 1;

  strcpy(out.anam,ein.enam);
  out.aums = ein.eums;
  if (zz >= ZZG)
  {
    NEUESEITE;
    zz = K0;
  }
  printf(F_OUT,out.anam,out.aums);
  zz = zz + K1;
} /* ----- Ende ausgabe */
