/* bung A07
   Autor: Beringer Alfred
   Schlerliste - Auswahl von Datenfeldern, unterschiedliche Ausgabezeilen.
 ---------------------------------------------------------------
  EINGABEDATEN: SCHLERDATEI
       AUFBAU:
         1 - 20 (20) ... FAMILIENNAME
        21 - 30 (10) ... VORNAME
           31   ( 1) ... GESCHLECHT
        32 - 39 ( 8) ... GEBURTSDATUM (IN DER FORM JJJJMMTT)
        40 - 41 ( 2) ... RELIGION (VERSCHLSSELT)
        42 - 44 ( 3) ... STAATSBRGERSCHAFT
        45 - 49 ( 5) ... KLASSE
        50 - 53 ( 4) ... POSTLEITZAHL
        54 - 65 (12) ... ORT
        66 - 80 (15) ... STRASSE
 ---------------------------------------------------------------
  AUSGABEDATEN: SCHLERLISTE
       AUFBAU:
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE FR JEDEN SCHLER MIT
                FAMILIENNAME
                VORNAME
                GEBURTSDATUM (NUR BEI MNNLICHEN SCHLERN!)
 
  PRO SEITE MAXIMAL 22 ZEILEN (EINSCHL. BERSCHRIFT + LEERZEILE).
  DIE BERSCHRIFT SOLL NIE ALLEIN AUF EINER SEITE STEHEN.
 ---------------------------------------------------------------
*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include "..\\Headerdateien\\clrscr.h"
#include "..\\Headerdateien\\makros.h"

#include "..\\Headerdateien\\schueler-EB.h"

//#define EINGABEDATEI  "..\\Dateien\\vormerk.datC"
#define EINGABEDATEI  "..\\Dateien\\schueler.datC"

#define ZZG   22
#define VG    'M'
#define KBL   "        "

#define ABU   "      FAMILIENNAME             VORNAME        GEBURTSDATUM\n"
#define F_AB  "      %s     %s       %s\n"

struct AB
{
  char afn [20+1],
       avn [10+1],
       agd [ 8+1];
};

void upanf(short int &zz);
void upva(EB eb, AB &ab);
void upausgabe(AB ab, short int &zz);
void upueb(short int &zz);

void main()
{
  FILE *VORMERK;
  //    LISTE = Standardausgabe stdout

  EB eb;
  AB ab;
  short int zz;

  VORMERK = fopen(EINGABEDATEI,"rb");

  upanf(zz);
  fread(&eb,sizeof(eb),1,VORMERK);
  while (!feof(VORMERK))
  {
    upva(eb,ab);
    upausgabe(ab,zz);
    fread(&eb,sizeof(eb),1,VORMERK);
  }

  fclose(VORMERK);

  _getch();
} /* ----- Ende main */

void upanf(short int &zz)
{
  zz = ZZG;
} /* ----- Ende upanf */

void upva(EB eb, AB &ab)
{
  strcpy(ab.afn,eb.efn);
  strcpy(ab.avn,eb.evn);
  if (eb.eg == VG)
    strcpy(ab.agd,eb.egd);
  else
    strcpy(ab.agd,KBL);
} /* ----- Ende upva */

void upausgabe(AB ab, short int &zz)
{
  const short int K1 = 1;

  if (zz >= ZZG)
    upueb(zz);
  printf(F_AB,ab.afn,ab.avn,ab.agd);
  zz = zz + K1;
} /* ----- Ende upausgabe */

void upueb(short int &zz)
{
  const short int K2 = 2;

  NEUESEITE;
  printf(ABU);
  LEERZEILE;
  zz = K2;
} /* ----- Ende upueb */
