/* bung A08
   Autor: Beringer Alfred
   Klassenliste - Auswahl von Datenstzen und Datenfeldern,
                  Konstante, Parameter, Literale.
 ---------------------------------------------------------------
  EINGABEDATEN: SCHLERDATEI
       AUFBAU:
         1 - 20 (20) ... FAMILIENNAME
        21 - 30 (10) ... VORNAME
           31   ( 1) ... GESCHLECHT
        32 - 39 ( 8) ... GEBURTSDATUM (IN DER FORM JJJJMMTT)
        40 - 41 ( 2) ... RELIGION (VERSCHLSSELT)
        42 - 44 ( 3) ... STAATSBRGERSCHAFT
        45 - 49 ( 5) ... KLASSE
        50 - 53 ( 4) ... POSTLEITZAHL
        54 - 65 (12) ... ORT
        66 - 80 (15) ... STRASSE
 ---------------------------------------------------------------
  AUSGABEDATEN: SCHLERLISTE FR DIE KLASSE 1BKDV
       AUFBAU:
         1 HAUPTBERSCHRIFT MIT DER AUSGEWHLTEN KLASSE
         1 LEERZEILE
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE FR JEDEN SCHLER AUS DER KLASSE 1BKDV.
             JEDE ZEILE MIT
                LAUFENDER NUMMER
                FAMILIENNAME
                VORNAME
                GEBURTSDATUM (NUR BEI MNNLICHEN SCHLERN!)
 
  PRO SEITE MAXIMAL 22 ZEILEN (EINSCHL. BERSCHRIFT + LEERZEILE).
  DIE BERSCHRIFT SOLL NIE ALLEIN AUF EINER SEITE STEHEN.
 ---------------------------------------------------------------
*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include "..\\Headerdateien\\clrscr.h"
#include "..\\Headerdateien\\makros.h"

#include "..\\Headerdateien\\schueler-EB.h"

//#define EINGABEDATEI  "..\\Dateien\\vormerk.datC"
#define EINGABEDATEI  "..\\Dateien\\schueler.datC"

#define ZMAX  22
#define VG    'M'
#define VKL   "1BKDV"

#define ABUE  "        1BKDV   LFD.NUMMER  FAMILIENNAME         VORNAME     GEBURTSDATUM\n"
#define F_AB  "                    %2hd      %s %s    %s  \n"

struct AB
{
  short int alnr;
  char      afn [20+1],
            avn [10+1],
            agd [ 8+1];
};

void upstart  (short int &zz,
               short int &rlnr);
void upva     (EB eb,
               AB &ab,
               short int &rlnr,
               short int &zz);
void upaber   (EB eb,
               AB &ab,
               short int &rlnr);
void upausgab (AB ab,
               short int &zz);
void upueb    (short int &zz);
void upueber  (short int &zz);

void main()
{
  FILE *SCHULE;
  //    KLISTE = Standardausgabe stdout

  EB eb;
  AB ab;
  short int zz,
            rlnr;

  SCHULE = fopen(EINGABEDATEI,"rb");

  upstart (zz,rlnr);
  fread(&eb,sizeof(eb),1,SCHULE);
  while (!feof(SCHULE))
  {
    if (strcmp(eb.ekl,VKL) == 0)
      upva(eb,ab,rlnr,zz);
    fread(&eb,sizeof(eb),1,SCHULE);
  }

  fclose(SCHULE);

  _getch();
} // ----- Ende main

void upstart(short int &zz,
             short int &rlnr)
{
  zz = ZMAX;
  rlnr = 0;
} // ----- Ende upstart

void upva(EB eb,
          AB &ab,
          short int &rlnr,
          short int &zz)
{
  upaber(eb,ab,rlnr);
  upausgab(ab,zz);
} // ----- Ende upva

void upaber(EB eb,
            AB &ab,
            short int &rlnr)
{
  rlnr++;
  ab.alnr = rlnr;
  strcpy(ab.afn,eb.efn);
  strcpy(ab.avn,eb.evn);
  if (eb.eg == VG)
    strcpy(ab.agd,eb.egd);
  else
    strcpy(ab.agd,"        ");
} // ----- Ende upaber

void upausgab(AB ab,
              short int &zz)
{
  upueb(zz);
  printf(F_AB,ab.alnr,ab.afn,ab.avn,ab.agd);
  zz++;
} // ----- Ende upausgab

void upueb(short int &zz)
{
  if (zz >= ZMAX)
    upueber(zz);
} // ----- Ende upueb

void upueber(short int &zz)
{
  NEUESEITE;
  printf(ABUE);
  LEERZEILE;
  zz = 2;
} // ----- Ende upueber
