/* bung A09
   Autor: Beringer Alfred
   Eingabe von Parametern ber Vorlaufsatz.
   Parametrisieren der bung A08 (Klassenliste).
 ---------------------------------------------------------------
  EINGABEDATEN: VORLAUFSATZ
       AUFBAU:
         1 -  7 ( 7) ... KONSTANTE KENNUNG 'KLASSE:'
           8    ( 1) ... LEER
         9 - 13 ( 5) ... AUSZUWHLENDE KLASSE
 
 ---------------------------------------------------------------
  EINGABEDATEN: SCHLERDATEI
       AUFBAU:
         1 - 20 (20) ... FAMILIENNAME
        21 - 30 (10) ... VORNAME
           31   ( 1) ... GESCHLECHT
        32 - 39 ( 8) ... GEBURTSDATUM (IN DER FORM JJJJMMTT)
        40 - 41 ( 2) ... RELIGION (VERSCHLSSELT)
        42 - 44 ( 3) ... STAATSBRGERSCHAFT
        45 - 49 ( 5) ... KLASSE
        50 - 53 ( 4) ... POSTLEITZAHL
        54 - 65 (12) ... ORT
        66 - 80 (15) ... STRASSE
 ---------------------------------------------------------------
  AUSGABEDATEN: SCHLERLISTE FR EINE EINZUGEBENDE KLASSE
       AUFBAU:
         1 HAUPTBERSCHRIFT MIT DER AUSGEWHLTEN KLASSE
         1 LEERZEILE
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE FR JEDEN SCHLER DER AUSGEWHLTEN KLASSE.
             JEDE ZEILE MIT
                LAUFENDER NUMMER
                FAMILIENNAME
                VORNAME
                GEBURTSDATUM (NUR BEI MNNLICHEN SCHLERN!)
 
  PRO SEITE MAXIMAL 20 ZEILEN (EINSCHL. BERSCHRIFT + LEERZEILE).
  DIE BERSCHRIFT SOLL NIE ALLEIN AUF EINER SEITE STEHEN.
 ---------------------------------------------------------------
*/

#include <stdio.h>
#include <string.h>
#include <iostream>
#include "..\\Headerdateien\\clrscr.h"

#include "..\\Headerdateien\\schueler-EB.h"

using namespace std;

//#define EINGABEDATEI  "..\\Dateien\\vormerk.datC"
#define EINGABEDATEI  "..\\Dateien\\schueler.datC"

/* Die Verwendung von cin schliet die gleichzeitige Verwendung der Funktion _getch()
   aus der Bibliothek conio.h aus. Allerdings muss bei Verwendung von cin nach Drcken
   einer Buchstaben- oder Zifferntaste auch noch die return-Taste gedrckt werden.
*/
#define NEUESEITE  printf("\nWeiter mit beliebiger Zeichen-Taste und danach return-Taste"); \
                   char x; cin >> x; clrscr()
#define LEERZEILE  printf("\n")

#define ZMAX      20
#define VG        'M'
#define VVTX      "KLASSE:"

#define ABEINGABE "Bitte geben Sie den Text 'KLASSE: ' und dazu eine Klasse ein:\n"

#define F_ABUE1   "                   S C H U E L E R L I S T E     FUER DIE KLASSE  %s\n"
#define ABUE2     "               LFD.NUMMER  FAMILIENNAME         VORNAME     GEBURTSDATUM\n"
#define F_AB      "                   %2hd      %s %s    %s\n"

#define ABF1      "VORLAUFSATZ FEHLT\n"
#define ABF2      "VORLAUFSATZ FALSCH\n"

struct VB
{
  char vtx[7+1],
       vkl[5+1];
};

struct ABUE1
{
  char akl[5+1];
};

struct AB
{
  short int alnr;
  char      afn[20+1],
            avn[10+1],
            agd[ 8+1];
};

void uproga8(VB vb,
             ABUE1 abue1);
void upstart(short int &zz,
             short int &rlnr);
void upva   (EB eb,
             ABUE1 abue1,
             short int &rlnr,
             short int &zz);
void upaber (EB eb,
             AB &ab,
             short int &rlnr);
void upueber(ABUE1 abue1,
             short int &zz);
void upfel1 ();
void upfel2 ();

void main()
{
  // VORLAUF = Standardeingabe stdin
  // KLISTE = Standardausgabe stdout

  VB    vb;
  ABUE1 abue1;

  // -----------------------------------
  printf(ABEINGABE);
  cin >> vb.vtx >> vb.vkl;
  if (cin.eof())
    upfel1();
  else
    if (strcmp(vb.vtx,VVTX) == 0)
    {
      strcpy(abue1.akl,vb.vkl);
      uproga8(vb,abue1);
    }
    else
      upfel2();
  // -----------------------------------
  NEUESEITE;
} // ***** Ende main

void uproga8(VB vb,
             ABUE1 abue1)
{
  FILE *SCHULE;

  EB eb;
  short int zz,
            rlnr;

  SCHULE = fopen(EINGABEDATEI,"rb");

  upstart(zz,rlnr);
  fread(&eb,sizeof(eb),1,SCHULE);
  while (!feof(SCHULE))
  {
    if (strcmp(eb.ekl,vb.vkl) == 0)
      upva(eb,abue1,rlnr,zz);
    fread(&eb,sizeof(eb),1,SCHULE);
  }

  fclose(SCHULE);
} // ***** Ende uproga8

void upstart(short int &zz,
             short int &rlnr)
{
  zz = ZMAX;
  rlnr = 0;
} // ***** Ende upstart

void upva(EB eb,
          ABUE1 abue1,
          short int &rlnr,
          short int &zz)
{
  AB ab;

  upaber(eb,ab,rlnr);
  if (zz >= ZMAX)
    upueber(abue1,zz);
  printf(F_AB, ab.alnr, ab.afn, ab.avn, ab.agd);
  zz++;
} // ***** Ende upva

void upaber(EB eb,
            AB &ab,
            short int &rlnr)
{
  rlnr++;
  ab.alnr = rlnr;
  strcpy(ab.afn,eb.efn);
  strcpy(ab.avn,eb.evn);
  if (eb.eg == VG)
    strcpy(ab.agd,eb.egd);
  else
    strcpy(ab.agd,"        ");
} // ***** Ende upaber

void upueber(ABUE1 abue1,
             short int &zz)
{
  NEUESEITE;
  printf(F_ABUE1,abue1.akl);
  LEERZEILE;
  printf(ABUE2);
  LEERZEILE;
  zz = 4;
} // ***** Ende upueber

void upfel1()
{
  NEUESEITE;
  printf(ABF1);
} // ***** Ende upfel1

void upfel2()
{
  NEUESEITE;
  printf(ABF2);
} // ***** Ende upfel2
